## nvidia-persistenced-390 390.87

=== Makefile ===
#
# nvidia-persistenced: A daemon for maintaining persistent driver state,
# specifically for use by the NVIDIA Linux driver.
#
# Copyright (C) 2013 NVIDIA Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#

##############################################################################
# include common variables and functions
##############################################################################

include utils.mk

##############################################################################
# assign variables
##############################################################################

NVIDIA_PERSISTENCED = $(OUTPUTDIR)/nvidia-persistenced

NVIDIA_PERSISTENCED_PROGRAM_NAME = "nvidia-persistenced"

MANPAGE_GZIP ?= 1

MANPAGE_not_gzipped = $(OUTPUTDIR)/nvidia-persistenced.1
MANPAGE_gzipped     = $(OUTPUTDIR)/nvidia-persistenced.1.gz

ifeq ($(MANPAGE_GZIP),1)
  MANPAGE = $(MANPAGE_gzipped)
else
  MANPAGE = $(MANPAGE_not_gzipped)
endif
GEN_MANPAGE_OPTS = $(OUTPUTDIR_ABSOLUTE)/gen-manpage-opts
OPTIONS_1_INC    = $(OUTPUTDIR)/options.1.inc

##############################################################################
# The calling Makefile may export any of the following variables; we assign
# default values if they are not exported by the caller
##############################################################################

RPC_DIR ?= .
NVIDIA_CFG_DIR ?= .
NVIDIA_NUMA_DIR ?= .

##############################################################################
# The common-utils directory may be in one of two places: either elsewhere in
# the driver source tree when building nvidia-persistenced as part of the
# NVIDIA driver build (in which case, COMMON_UTILS_DIR should be defined by
# the calling makefile), or directly in the source directory when building
# from the nvidia-persistenced source tarball (in which case, the below
# conditional assignment should be used)
##############################################################################

COMMON_UTILS_DIR ?= common-utils

# include the list of source files; defines SRC
include dist-files.mk

# $(STAMP_C) defines the version string generated by utils.mk, containing
# information about the build environment.
SRC += $(STAMP_C)

include $(COMMON_UTILS_DIR)/src.mk
SRC += $(addprefix $(COMMON_UTILS_DIR)/,$(COMMON_UTILS_SRC))

# rpcgen generates code that emits unused variable warnings
$(call BUILD_OBJECT_LIST,$(RPC_SRC)): CFLAGS += -Wno-unused-variable

OBJS = $(call BUILD_OBJECT_LIST,$(SRC))

common_cflags += -I $(COMMON_UTILS_DIR)
common_cflags += -I $(NVIDIA_CFG_DIR)
common_cflags += -I $(NVIDIA_NUMA_DIR)
common_cflags += -I $(RPC_DIR)
common_cflags += -I .

include version.mk
common_cflags += -DPROGRAM_NAME=\"$(NVIDIA_PERSISTENCED_PROGRAM_NAME)\"
common_cflags += -D_BSD_SOURCE
common_cflags += -D_XOPEN_SOURCE=500
common_cflags += -std=c99

CFLAGS += $(common_cflags)
HOST_CFLAGS += $(common_cflags)

ifneq ($(TARGET_OS),FreeBSD)
  LIBS += -ldl
endif

##############################################################################
# build rules
##############################################################################
.PHONY: all install NVIDIA_PERSISTENCED_install MANPAGE_install clean clobber

all: $(NVIDIA_PERSISTENCED) $(MANPAGE)

install: NVIDIA_PERSISTENCED_install MANPAGE_install

NVIDIA_PERSISTENCED_install: $(NVIDIA_PERSISTENCED)
	$(MKDIR) $(BINDIR)
	$(INSTALL) $(INSTALL_BIN_ARGS) $< $(BINDIR)/$(notdir $<)

MANPAGE_install: $(MANPAGE)
	$(MKDIR) $(MANDIR)
	$(INSTALL) $(INSTALL_BIN_ARGS) $< $(MANDIR)/$(notdir $<)

$(eval $(call DEBUG_INFO_RULES, $(NVIDIA_PERSISTENCED)))
$(NVIDIA_PERSISTENCED).unstripped: $(OBJS)
	$(call quiet_cmd,LINK) $(CFLAGS) $(LDFLAGS) $(BIN_LDFLAGS) \
		-o $@ $(OBJS) $(LIBS)

# define the rule to build each object file
$(foreach src, $(SRC), $(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))

# define the rule to generate $(STAMP_C)
$(eval $(call DEFINE_STAMP_C_RULE, \
	$(OBJS),$(NVIDIA_PERSISTENCED_PROGRAM_NAME)))

clean clobber:
	$(RM) -rf $(NVIDIA_PERSISTENCED) $(MANPAGE) *~ $(STAMP_C) \
		$(OUTPUTDIR)/*.o $(OUTPUTDIR)/*.d \
		$(GEN_MANPAGE_OPTS) $(OPTIONS_1_INC)

##############################################################################
# documentation
##############################################################################

AUTO_TEXT = ".\\\" WARNING: THIS FILE IS AUTO_GENERATED!  Edit $< instead."

doc: $(MANPAGE)

GEN_MANPAGE_OPTS_SRC = gen-manpage-opts.c
GEN_MANPAGE_OPTS_SRC += $(COMMON_UTILS_DIR)/gen-manpage-opts-helper.c

GEN_MANPAGE_OPTS_OBJS = $(call BUILD_OBJECT_LIST,$(GEN_MANPAGE_OPTS_SRC))

$(foreach src,$(GEN_MANPAGE_OPTS_SRC), \
    $(eval $(call DEFINE_OBJECT_RULE,HOST,$(src))))

$(GEN_MANPAGE_OPTS): $(GEN_MANPAGE_OPTS_OBJS)
	$(call quiet_cmd,HOST_LINK) \
		$(HOST_CFLAGS) $(HOST_LDFLAGS) $(HOST_BIN_LDFLAGS) $^ -o $@

$(OPTIONS_1_INC): $(GEN_MANPAGE_OPTS)
	@$< > $@

$(MANPAGE_not_gzipped): nvidia-persistenced.1.m4 $(OPTIONS_1_INC) $(VERSION_MK)
	$(call quiet_cmd,M4) -D__HEADER__=$(AUTO_TEXT) -I $(OUTPUTDIR) \
	  -D__VERSION__=$(NVIDIA_VERSION) \
	  -D__DATE__="`$(DATE) +%F`" \
	  -D__BUILD_OS__=$(TARGET_OS) \
	  $< > $@

$(MANPAGE_gzipped): $(MANPAGE_not_gzipped)
	$(GZIP_CMD) -9f < $< > $@

=== debian/changelog ===
nvidia-persistenced-390 (390.87-1~deb9u1) stretch; urgency=medium

  * Rebuild for stretch.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 Feb 2019 23:11:08 +0100

nvidia-persistenced-390 (390.87-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.3.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 17 Jan 2019 22:45:48 +0100

nvidia-persistenced-390 (390.25-1) unstable; urgency=medium

  * New upstream release.
  * Add debian/upstream/metadata.
  * Fix new Lintian issues.
  * Switch Vcs-* URLs to salsa.debian.org.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 06 Mar 2018 04:13:59 +0100

nvidia-persistenced-390 (384.111-1~deb9u1) stretch; urgency=medium

  * Rebuild for stretch.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 26 Feb 2018 00:36:01 +0100

nvidia-persistenced-390 (384.111-1) unstable; urgency=medium

  * New upstream release.
  * B-D: dpkg-dev (>= 1.18.8) for SOURCE_DATE_EPOCH in pkg-info.mk.
  * Bump Standards-Version to 4.1.3. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 13 Jan 2018 18:40:41 +0100

nvidia-persistenced-390 (384.98-1) unstable; urgency=medium

  * New upstream release.
  * Use https:// URL in the watch file.
  * Bump Standards-Version to 4.1.1. No changes needed.
  * Set Rules-Requires-Root: no.
  * Use dpkg makefile snippets instead of manual changelog parsing.
  * Use a fixed OUTPUTDIR for improved reproducibility.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 17 Nov 2017 02:50:48 +0100

nvidia-persistenced-390 (375.26-2) unstable; urgency=medium

  * Add Depends: libnvidia-cfg1 | libnvidia-cfg1-any, thanks to Gero Müller.
  * Do not build for ppc64el which does not have a curent driver packaged.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 18 Jan 2017 16:16:20 +0100

nvidia-persistenced-390 (375.26-1) unstable; urgency=medium

  * New upstream release.
  * Switch to debhelper compat level 10.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 13 Jan 2017 03:21:35 +0100

nvidia-persistenced-390 (367.57-1) unstable; urgency=medium

  * New upstream release.
    - Fixed a bug in nvidia-persistenced-390 that caused it to incorrectly delete
      the PID file if a second instance of the daemon is started.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 15 Oct 2016 16:28:30 +0200

nvidia-persistenced-390 (367.44-1) unstable; urgency=medium

  * New upstream release.
    - Changed the behavior of nvidia-persistenced-390 to enable persistence mode
      by default for all GPUs when the daemon is started.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 08 Oct 2016 15:10:39 +0200

nvidia-persistenced-390 (367.18-1) unstable; urgency=medium

  * New upstream release.
    * Allows overriding the stripping options.
  * Enable more hardening.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 30 May 2016 09:53:44 +0200

nvidia-persistenced-390 (364.15-2) unstable; urgency=medium

  * Multi-Arch: foreign, not allowed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 19 Apr 2016 23:45:13 +0200

nvidia-persistenced-390 (364.15-1) unstable; urgency=medium

  * New upstream release.
  * Mark as Multi-Arch: allowed.
  * Simplify rules and clean up properly.
  * Fix upstream build system to allow creation of unstripped binaries.
  * Bump Standards-Version to 3.9.8. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 19 Apr 2016 23:24:39 +0200

nvidia-persistenced-390 (361.28-1) unstable; urgency=medium

  * New upstream release.
  * Build for ppc64el.
  * Update Vcs-Git URL.
  * Bump Standards-Version to 3.9.7. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Feb 2016 01:15:17 +0100

nvidia-persistenced-390 (358.09-1) unstable; urgency=medium

  * New upstream release.
  * Fix Vcs-Browser URL.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 08 Nov 2015 02:22:34 +0100

nvidia-persistenced-390 (352.21-1) unstable; urgency=medium

  * New upstream release.
  * Update d/copyright: Upstream source is consistently licensed under Expat
    since 349.12, previously common-utils/* was under GPL-2.
  * d/rules: Make the build reproducible by using deterministic timestamp,
    user and hostname strings to be included in the binary. Based on patch for
    nvidia-settings by Jérémy Bobbio.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 21 Jun 2015 17:28:54 +0200

nvidia-persistenced-390 (343.13-1) unstable; urgency=low

  * Initial release.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 29 Oct 2014 12:54:27 +0100

=== debian/control ===
Source: nvidia-persistenced-390
Section: contrib/utils
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper (>= 10),
 dpkg-dev (>= 1.18.8),
 m4,
Rules-Requires-Root: no
Standards-Version: 4.3.0
Homepage: https://github.com/NVIDIA/nvidia-persistenced
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-persistenced
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-persistenced.git

Package: nvidia-persistenced-390
Architecture: i386 amd64 armhf
Multi-Arch: foreign
Depends:
 libnvidia-cfg1 | libnvidia-cfg1-any,
 ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 nvidia-persistenced,
 nvidia-persistenced-460,
 nvidia-persistenced-470,
Breaks:
 nvidia-driver (<< 340.46-4~),
Replaces:
 nvidia-driver (<< 340.46-4~),
 nvidia-persistenced,
 nvidia-persistenced-460,
 nvidia-persistenced-470,
Description: daemon to maintain persistent software state in the NVIDIA driver
 When persistence mode is enabled, the daemon prevents the driver from
 releasing device state when the device is not in use.
 This can improve the startup time of new clients in this scenario.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export NV_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# Redefine DATE to something stable to make the build reproducible
export DATE		 = date -d "@$(SOURCE_DATE_EPOCH)"
# Cheat for user and hostname
export WHOAMI		 = echo buildd
export HOSTNAME_CMD	 = echo debian

export PREFIX		 = /usr
export DO_STRIP		 =
export CC_ONLY_CFLAGS	 = $(CPPFLAGS)
export OUTPUTDIR	 = _out/debian

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
export DEBUG		 = 1
endif


%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	chmod -R a-sx,u=rwX,go=rX init

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -r _out
